      SUBROUTINE AGT1R(A,B,ALFR,ALFI,BETA,N,IERR)
      DIMENSION A(N,N),B(N,N),ALFR(N),ALFI(N),BETA(N)
      INTEGER N,IERR,M,L,I,J
      REAL A,B,ALFR,ALFI,BETA,ZERO,HALF,ONE,EPS,EPSB,BNORM,SYS051,
     1BNI,U1,U2,V1,V2,F,AN,A11,A12,A21,A22,A11R,A11I,A12R,
     1A12I,A21R,A21I,A22R,A22I,BN,B11,B12,B22,E,C,D,T,ER,EI,
     1CZ,SZR,CQ,SQR,SQI,SSR,SSI,TR,TI,BDR,BDI,R,SZI
      LOGICAL FLIP
      DATA  ZERO/0./,ONE/1./,HALF/0.5/,SYS051/1.192093E-07/
      EPS=SYS051
      IERR=0
      CALL AFT0R(A,B,A,N,1,IERR)
      BNORM=ZERO
      DO 2 I=1,N
      BNI=ZERO
      DO 1 J=1,N
      BNI=BNI+ABS(B(I,J))
    1 CONTINUE
      IF(BNI.GT.BNORM) BNORM=BNI
    2 CONTINUE
      IF(BNORM.EQ.ZERO) BNORM=EPS
      EPSB=EPS*BNORM
      M=N
    3 CONTINUE
      IF(M.EQ.1) GO TO 4
      IF(A(M,M-1).NE.ZERO) GO TO 5
    4 ALFR(M)=A(M,M)
      IF(B(M,M).LT.ZERO) ALFR(M)=-ALFR(M)
      BETA(M)=ABS(B(M,M))
      ALFI(M)=ZERO
      M=M-1
      GO TO 15
    5 L=M-1
      IF(ABS(B(L,L)).GT.EPSB) GO TO 6
      B(L,L)=ZERO
      CALL AM12R(A(L,L),A(M,L),U1,U2,V1,V2)
      GO TO 11
    6 IF(ABS(B(M,M)).GT.EPSB) GO TO 7
      B(M,M)=ZERO
      CALL AM12R(A(M,M),A(M,L),U1,U2,V1,V2)
      BN=ZERO
      GO TO 8
    7 AN=ABS(A(L,L))+ABS(A(L,M))+ABS(A(M,L))+ABS(A(M,M))
      BN=ABS(B(L,L))+ABS(B(L,M))+ABS(B(M,M))
      F=ONE/AN
      A11=A(L,L)*F
      A12=A(L,M)*F
      A21=A(M,L)*F
      A22=A(M,M)*F
      F=ONE/BN
      B11=B(L,L)*F
      B12=B(L,M)*F
      B22=B(M,M)*F
      E=A11/B11
      C=((A22-E*B22)/B22-(A21*B12)/(B11*B22))*HALF
      D=C*C+(A21*(A12-E*B12))/(B11*B22)
      IF(D.LT.ZERO) GO TO 14
      IF(C.GE.ZERO) E=E+(C+SQRT(D))
      IF(C.LT.ZERO) E=E+(C-SQRT(D))
      A11=A11-E*B11
      A12=A12-E*B12
      A22=A22-E*B22
      FLIP=(ABS(A11)+ABS(A12)).GE.(ABS(A21)+ABS(A22))
      IF(FLIP) CALL AM12R(A12,A11,U1,U2,V1,V2)
      IF(.NOT.FLIP) CALL AM12R(A22,A21,U1,U2,V1,V2)
    8 IF(U1.NE.ONE) GO TO 10
      DO 9 I=1,M
      T=A(I,M)+U2*A(I,L)
      A(I,M)=A(I,M)+V1*T
      A(I,L)=A(I,L)+V2*T
      T=B(I,M)+U2*B(I,L)
      B(I,M)=B(I,M)+V1*T
      B(I,L)=B(I,L)+V2*T
    9 CONTINUE
   10 IF(BN.EQ.ZERO) GO TO 13
      FLIP=AN.GE.ABS(E)*BN
      IF(FLIP) CALL AM12R(B(L,L),B(M,L),U1,U2,V1,V2)
      IF(.NOT.FLIP) CALL AM12R(A(L,L),A(M,L),U1,U2,V1,V2)
   11 IF(U1.NE.ONE) GO TO 13
      DO 12 J=L,N
      T=A(L,J)+U2*A(M,J)
      A(L,J)=A(L,J)+V1*T
      A(M,J)=A(M,J)+V2*T
      T=B(L,J)+U2*B(M,J)
      B(L,J)=B(L,J)+V1*T
      B(M,J)=B(M,J)+V2*T
   12 CONTINUE
   13 A(M,L)=ZERO
      B(M,L)=ZERO
      ALFR(L)=A(L,L)
      ALFR(M)=A(M,M)
      IF(B(L,L).LT.ZERO) ALFR(L)=-ALFR(L)
      IF(B(M,M).LT.ZERO) ALFR(M)=-ALFR(M)
      BETA(L)=ABS(B(L,L))
      BETA(M)=ABS(B(M,M))
      ALFI(M)=ZERO
      ALFI(L)=ZERO
      M=M-2
      GO TO 15
   14 ER=E+C
      EI=SQRT(-D)
      A11R=A11-ER*B11
      A11I=EI*B11
      A12R=A12-ER*B12
      A12I=EI*B12
      A21R=A21
      A21I=ZERO
      A22R=A22-ER*B22
      A22I=EI*B22
      FLIP=(ABS(A11R)+ABS(A11I)+ABS(A12R)+ABS(A12I))
     1.GE.(ABS(A21R)+ABS(A22R)+ABS(A22I))
      IF(FLIP) CALL AM12C(A12R,A12I,-A11R,-A11I,CZ,SZR,SZI)
      IF(.NOT.FLIP) CALL AM12C(A22R,A22I,-A21R,-A21I,CZ,SZR,SZI)
      FLIP=AN.GE.(ABS(ER)+ABS(EI))*BN
      IF(FLIP) CALL AM12C(CZ*B11+SZR*B12,SZI*B12,SZR*B22,
     1SZI*B22,CQ,SQR,SQI)
      IF(.NOT.FLIP) CALL AM12C(CZ*A11+SZR*A12, SZI*A12,CZ*
     1A21+SZR*A22, SZI*A22,CQ,SQR,SQI)
      SSR=SQR*SZR+SQI*SZI
      SSI=SQR*SZI-SQI*SZR
      TR=CQ*CZ*A11+CQ*SZR*A12+SQR*CZ*A21+SSR*A22
      TI=CQ*SZI*A12-SQI*CZ*A21+SSI*A22
      BDR=CQ*CZ*B11+CQ*SZR*B12+SSR*B22
      BDI=CQ*SZI*B12+SSI*B22
      R=SQRT(BDR*BDR+BDI*BDI)
      BETA(L)=BN*R
      ALFR(L)=AN*(TR*BDR+TI*BDI)/R
      ALFI(L)=AN*(TR*BDI-TI*BDR)/R
      TR=SSR*A11-SQR*CZ*A12-CQ*SZR*A21+CQ*CZ*A22
      TI=-SSI*A11-SQI*CZ*A12+CQ*SZI*A21
      BDR=SSR*B11-SQR*CZ*B12+CQ*CZ*B22
      BDI=-SSI*B11-SQI*CZ*B12
      R=SQRT(BDR*BDR+BDI*BDI)
      BETA(M)=BN*R
      ALFR(M)=AN*(TR*BDR+TI*BDI)/R
      ALFI(M)=AN*(TR*BDI-TI*BDR)/R
      M=M-2
   15 IF(M.GT.0) GO TO 3
      IF(IERR.NE.0) CALL UTAG10(IERR,42)
      RETURN
      END
